#ifndef I2C_H
#define I2C_H

#include "p24fj48ga002.h"

//The Slave ADdress (SAD) associated to the LIS302DL is 0011100 (when SDO is tied to GND), 
//lsb indicates the R	/W mode.
#define DEVICE_WRITE    0x38 //Default LIS302DL I2C address - write
#define DEVICE_READ     0x39 //Default LIS302DL I2C address - read

#define ACK     1
#define NO_ACK  0

#define XTFREQ 16000000 //On-board Crystal frequency
//#define PLLMODE (1/2) //On-chip PLL setting
#define FCY XTFREQ/2 //Instruction Cycle Frequency

/*************************************
**functions prototypes				**
*************************************/

void InitI2C1(void);
void reset_i2c_bus(void);

void writeRegister(unsigned char regAdd, unsigned char regVal);

unsigned char readRegister(unsigned char regAdd);

#endif
