#include "p24fj48ga002.h"
#include "aux_func.h"

#define USE_AND_OR	// To enable AND_OR mask setting for I2C. 
#include <i2c.h>

unsigned char i2c_i;		// used for i2c transceiving 
unsigned char tx_data[] = {'M', 'C', 'H', 'P', ' ', 'I', '2', 'C', '\0'};
unsigned char rx_data[7];	// "PIC24F"


void InitI2C2(void)
{
	mI2C2_SlaveClearIntr();		// clears the I2C Slave interrupt flag
	IEC3bits.SI2C2IE = 1;			// enables I2C Slave Interrupt
	
	//Enable channel
	OpenI2C2( I2C_ON, 0 );		// BRG is not used for I2C slave

	I2C2ADD = 0x61;	/* 0b1100001 Slave MCU address (customized)
					 * 4 msb is 1100, customized as slave MCU
					 * 3 lsb is 001, customized as the first slave MCU
					 */
}					 

void __attribute__((interrupt, no_auto_psv)) _SI2C2Interrupt(void)
{
	LATBbits.LATB14 = 1;
	if (I2C2STATbits.D_A==0) //Indicates that the last byte received was device address
	{
		// address byte
		i2c_i = 0;			// clear array to first
		rx_data[i2c_i] = SlavegetcI2C2();
		
		if (I2C2STATbits.R_W) 
		{
			// read from slave, data transfer is output from slave
			//SlaveputcI2C2(tx_data[i2c_i++]);	// put one char to i2c buffer
			LATBbits.LATB15 = 1;
			SlaveputcI2C2('M');	// put one char to i2c buffer
			wait(10);
			LATBbits.LATB15 = 0;
		}	
	} 
	else 
	{
		// data byte
		if (I2C2STATbits.R_W) 
		{
			// read from slave, data transfer is output from slave
			SlaveputcI2C2(tx_data[i2c_i++]);	// put one char to i2c buffer
		} 
		else 
		{
			// write to slave
			rx_data[i2c_i++] = SlavegetcI2C2();	// get one char from i2c buffer
		}
		//__builtin_btg((unsigned int *)&LATB, 12);
	}
	
	LATBbits.LATB14 = 0;
	mI2C2_SlaveClearIntr();		// clears the I2C Slave interrupt flag
}

